diff --git a/base/util/src/netscape/security/x509/RevocationReason.java b/base/util/src/netscape/security/x509/RevocationReason.java
index cbd7fe73d0cb0f2104fc15ca61a4a85dcab2d3b4..3454f805924f1fd0eb5b40aea440221016e2f522 100644
--- a/base/util/src/netscape/security/x509/RevocationReason.java
+++ b/base/util/src/netscape/security/x509/RevocationReason.java
@@ -17,6 +17,11 @@
 // --- END COPYRIGHT BLOCK ---
 package netscape.security.x509;
 
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.LinkedHashMap;
+import java.util.Map;
+
 /**
  * Represent the enumerated type used in CRLReason Extension of CRL entry.
  *
@@ -26,94 +31,97 @@ package netscape.security.x509;
  */
 
 public final class RevocationReason {
+
+    public static final Collection<RevocationReason> INSTANCES = new ArrayList<RevocationReason>();
+    public static final Map<Integer, RevocationReason> CODES = new LinkedHashMap<Integer, RevocationReason>();
+    public static final Map<String, RevocationReason> LABELS = new LinkedHashMap<String, RevocationReason>();
+
     /**
      * Reasons
      */
-    public static final RevocationReason UNSPECIFIED = new RevocationReason(0);
-    public static final RevocationReason KEY_COMPROMISE = new RevocationReason(1);
-    public static final RevocationReason CA_COMPROMISE = new RevocationReason(2);
-    public static final RevocationReason AFFILIATION_CHANGED = new RevocationReason(3);
-    public static final RevocationReason SUPERSEDED = new RevocationReason(4);
-    public static final RevocationReason CESSATION_OF_OPERATION = new RevocationReason(5);
-    public static final RevocationReason CERTIFICATE_HOLD = new RevocationReason(6);
-    public static final RevocationReason REMOVE_FROM_CRL = new RevocationReason(8);
-    public static final RevocationReason PRIVILEGE_WITHDRAWN = new RevocationReason(9);
-    public static final RevocationReason AA_COMPROMISE = new RevocationReason(10);
+    public static final RevocationReason UNSPECIFIED = new RevocationReason(0, "Unspecified");
+    public static final RevocationReason KEY_COMPROMISE = new RevocationReason(1, "Key_Compromise");
+    public static final RevocationReason CA_COMPROMISE = new RevocationReason(2, "CA_Compromise");
+    public static final RevocationReason AFFILIATION_CHANGED = new RevocationReason(3, "Affiliation_Changed");
+    public static final RevocationReason SUPERSEDED = new RevocationReason(4, "Superseded");
+    public static final RevocationReason CESSATION_OF_OPERATION = new RevocationReason(5, "Cessation_of_Operation");
+    public static final RevocationReason CERTIFICATE_HOLD = new RevocationReason(6, "Certificate_Hold");
+    public static final RevocationReason REMOVE_FROM_CRL = new RevocationReason(8, "Remove_from_CRL");
+    public static final RevocationReason PRIVILEGE_WITHDRAWN = new RevocationReason(9, "Privilege_Withdrawn");
+    public static final RevocationReason AA_COMPROMISE = new RevocationReason(10, "AA_Compromise");
 
     // Private data members
-    private int mReason;
+    private int code;
+    private String label;
 
     /**
-     * Create a RevocationReason with the passed integer value.
+     * Create a RevocationReason with the passed integer value and string label.
      *
      * @param reason integer value of the enumeration alternative.
+     * @param label string value of the enumeration alternative.
      */
-    private RevocationReason(int reason) {
-        this.mReason = reason;
+    private RevocationReason(int reason, String label) {
+        this.code = reason;
+        this.label = label;
+
+        INSTANCES.add(this);
+        CODES.put(reason, this);
+        LABELS.put(label.toLowerCase(), this);
+    }
+
+    public int getCode() {
+        return code;
     }
 
-    public int toInt() {
-        return mReason;
+    public String getLabel() {
+        return label;
     }
 
     public static RevocationReason fromInt(int reason) {
-        if (reason == UNSPECIFIED.mReason)
-            return UNSPECIFIED;
-        if (reason == KEY_COMPROMISE.mReason)
-            return KEY_COMPROMISE;
-        if (reason == CA_COMPROMISE.mReason)
-            return CA_COMPROMISE;
-        if (reason == AFFILIATION_CHANGED.mReason)
-            return AFFILIATION_CHANGED;
-        if (reason == SUPERSEDED.mReason)
-            return SUPERSEDED;
-        if (reason == CESSATION_OF_OPERATION.mReason)
-            return CESSATION_OF_OPERATION;
-        if (reason == CERTIFICATE_HOLD.mReason)
-            return CERTIFICATE_HOLD;
-        if (reason == REMOVE_FROM_CRL.mReason)
-            return REMOVE_FROM_CRL;
-        if (reason == PRIVILEGE_WITHDRAWN.mReason)
-            return PRIVILEGE_WITHDRAWN;
-        if (reason == AA_COMPROMISE.mReason)
-            return AA_COMPROMISE;
-        return null;
+        return valueOf(reason);
     }
 
-    public boolean equals(Object other) {
-        if (this == other)
+    public static RevocationReason valueOf(int reason) {
+        return CODES.get(reason);
+    }
+
+    public static RevocationReason valueOf(String string) {
+        return LABELS.get(string.toLowerCase());
+    }
+
+    public int toInt() {
+        return code;
+    }
+
+    public String toString() {
+        return label;
+    }
+
+    @Override
+    public boolean equals(Object obj) {
+        if (this == obj)
             return true;
-        else if (other instanceof RevocationReason)
-            return ((RevocationReason) other).mReason == mReason;
-        else
+        if (obj == null)
             return false;
+        if (getClass() != obj.getClass())
+            return false;
+        RevocationReason other = (RevocationReason) obj;
+        if (code != other.code)
+            return false;
+        if (label == null) {
+            if (other.label != null)
+                return false;
+        } else if (!label.equals(other.label))
+            return false;
+        return true;
     }
 
+    @Override
     public int hashCode() {
-        return mReason;
-    }
-
-    public String toString() {
-        if (equals(UNSPECIFIED))
-            return "Unspecified";
-        if (equals(KEY_COMPROMISE))
-            return "Key_Compromise";
-        if (equals(CA_COMPROMISE))
-            return "CA_Compromise";
-        if (equals(AFFILIATION_CHANGED))
-            return "Affiliation_Changed";
-        if (equals(SUPERSEDED))
-            return "Superseded";
-        if (equals(CESSATION_OF_OPERATION))
-            return "Cessation_of_Operation";
-        if (equals(CERTIFICATE_HOLD))
-            return "Certificate_Hold";
-        if (equals(REMOVE_FROM_CRL))
-            return "Remove_from_CRL";
-        if (equals(PRIVILEGE_WITHDRAWN))
-            return "Privilege_Withdrawn";
-        if (equals(AA_COMPROMISE))
-            return "AA_Compromise";
-        return "[UNDEFINED]";
+        final int prime = 31;
+        int result = 1;
+        result = prime * result + code;
+        result = prime * result + ((label == null) ? 0 : label.hashCode());
+        return result;
     }
 }
diff --git a/base/common/src/com/netscape/certsrv/dbs/certdb/CertIdAdapter.java b/base/util/src/netscape/security/x509/RevocationReasonAdapter.java
similarity index 60%
copy from base/common/src/com/netscape/certsrv/dbs/certdb/CertIdAdapter.java
copy to base/util/src/netscape/security/x509/RevocationReasonAdapter.java
index cfafff0642a64dfce5a488940bfd0931916bc98a..e9445bb4338c21e18d5d360f8f9aaf37d4b9b1a1 100644
--- a/base/common/src/com/netscape/certsrv/dbs/certdb/CertIdAdapter.java
+++ b/base/util/src/netscape/security/x509/RevocationReasonAdapter.java
@@ -12,26 +12,27 @@
 // with this program; if not, write to the Free Software Foundation, Inc.,
 // 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 //
-// (C) 2007 Red Hat, Inc.
+// (C) 2012 Red Hat, Inc.
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
-package com.netscape.certsrv.dbs.certdb;
+package netscape.security.x509;
 
 import javax.xml.bind.annotation.adapters.XmlAdapter;
 
+import org.apache.commons.lang.StringUtils;
+
 /**
- * The CertIdAdapter class provides custom marshaling for CertId.
+ * The RevocationReasonAdapter class provides custom marshaling for RevocationReason.
  *
  * @author Endi S. Dewata
- * @version $Revision$ $Date$
  */
-public class CertIdAdapter extends XmlAdapter<String, CertId> {
+public class RevocationReasonAdapter extends XmlAdapter<String, RevocationReason> {
 
-    public CertId unmarshal(String value) throws Exception {
-        return new CertId(value);
+    public RevocationReason unmarshal(String value) throws Exception {
+        return StringUtils.isEmpty(value) ? null : RevocationReason.valueOf(value);
     }
 
-    public String marshal(CertId value) throws Exception {
-        return value.toString();
+    public String marshal(RevocationReason value) throws Exception {
+        return value == null ? null : value.toString();
     }
-}
+}
\ No newline at end of file
-- 
1.7.7.6

